﻿Type=StaticCode
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public MyTheme As ABMTheme	
	Private ABM As ABMaterial 'ignore	
	Public NeedsAuthorization As Boolean = False
	Public AppVersion As String = "v20161222"
	Public AppPublishedStartURL As String = "http://www.rwblinn.de"
End Sub

Public Sub NavigateToPage(ws As WebSocket, TargetUrl As String)	
	If AppVersion <> "" Then
		TargetUrl = TargetUrl & "?" & AppVersion
	End If
	If ws.Open Then
		ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))			
	End If
End Sub

' build methods for ABM objects
Sub BuildTheme(themeName As String)
	MyTheme.Initialize(themeName)
	
	' Page theme
	MyTheme.Page.BackColor = ABM.COLOR_TEAL
	MyTheme.Page.BackColorIntensity = ABM.INTENSITY_LIGHTEN5
	
	' Header theme
	MyTheme.AddRowTheme("headertheme")
	MyTheme.Row("headertheme").BackColor = ABM.COLOR_TEAL
	MyTheme.Row("headertheme").BackColorIntensity = ABM.INTENSITY_DARKEN1	

	' Footer theme
	MyTheme.AddContainerTheme("footertheme")
	MyTheme.Container("footertheme").BackColor = ABM.COLOR_TEAL
	MyTheme.Container("footertheme").BackColorIntensity = ABM.INTENSITY_LIGHTEN2
	
	' Footer label theme
	MyTheme.AddLabelTheme("whitefc")
	MyTheme.Label("whitefc").ForeColor = ABM.COLOR_WHITE
	
	' Footer label theme
	MyTheme.AddLabelTheme("justify")
	MyTheme.Label("justify").align = ABM.TEXTALIGN_JUSTIFY
		
	' Label theme
	MyTheme.AddLabelTheme("lightblue")
	MyTheme.Label("lightblue").ForeColor = ABM.COLOR_LIGHTBLUE	
	MyTheme.Label("lightblue").ForeColorIntensity = ABM.INTENSITY_DARKEN2

	MyTheme.AddLabelTheme("bluefc")
	MyTheme.Label("bluefc").ForeColor = ABM.COLOR_BLUE

	MyTheme.AddLabelTheme("redfc")
	MyTheme.Label("redfc").ForeColor = ABM.COLOR_BLUE

	MyTheme.AddButtonTheme("buttonon")
	MyTheme.Button("buttonon").ForeColor = ABM.COLOR_WHITE
	MyTheme.Button("buttonon").BackColor = ABM.COLOR_GREEN

	MyTheme.AddButtonTheme("buttonoff")
	MyTheme.Button("buttonoff").ForeColor = ABM.COLOR_WHITE
	MyTheme.Button("buttonoff").BackColor = ABM.COLOR_RED
	
	MyTheme.AddToastTheme("toasttheme")
	MyTheme.Toast("toasttheme").ForeColor = ABM.COLOR_WHITE
	MyTheme.Button("buttonoff").BackColor = ABM.COLOR_BLUE
	MyTheme.Toast("toasttheme").Rounded = True
	
	MyTheme.AddSwitchTheme("switchtheme")
	MyTheme.Switch("switchtheme").SwitchOnColor = ABM.COLOR_GREEN
	MyTheme.Switch("switchtheme").SwitchOnColorIntensity = ABM.INTENSITY_DARKEN4
	MyTheme.Switch("switchtheme").SwitchOffColor = ABM.COLOR_RED
	MyTheme.Switch("switchtheme").SwitchOffColorIntensity = ABM.INTENSITY_DARKEN4
	MyTheme.Switch("switchtheme").LabelColor = ABM.COLOR_BLACK
	MyTheme.Switch("switchtheme").LabelColor = ABM.INTENSITY_DARKEN4
	MyTheme.Switch("switchtheme").LabelFontSize = "28px"
	MyTheme.Switch("switchtheme").Colorize(ABM.COLOR_TEAL)
End Sub

public Sub BuildParagraph(page As ABMPage, id As String, Text As String) As ABMLabel
	Dim lbl As ABMLabel	
	lbl.Initialize(page, id, Text , ABM.SIZE_PARAGRAPH, False, "")
	Return lbl
End Sub

' Build a fixed footer 
public Sub BuildFooterFixed(page As ABMPage)	
	page.isFixedFooter= True
	page.PaddingBottom = 150
	' Add a new row
	page.Footer.AddRows(1, True, "").AddCellsOS(2,0,0,0,6,6,6, "") 
	' Build the grid
	page.Footer.BuildGrid 
	page.Footer.UseTheme("footertheme")
	
	' Add a label to Row 1, Cell 1
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, "footlbl1", $"B4J HowTo by {AL}http://www.rwblinn.de{AT}rwblinn.de{/AL}{BR}{BR}${Main.Version}"$,ABM.SIZE_PARAGRAPH, False, "whitefc")
	page.Footer.Cell(1,1).AddComponent(lbl1)
	
	' Add a label to Row 1, Cell 1
	Dim lbl2 As ABMLabel
	lbl2.Initialize(page, "footlbl2", "ABMaterial by {AL}http://alwaysbusycorner.com/abmaterial{AT}Alain Bailleul{/AL}{BR}{BR}B4J by {AL}http://www.bx4.com{AT}Anywhere Software{/AL}",ABM.SIZE_PARAGRAPH, False, "whitefc")
	page.Footer.Cell(1,2).AddComponent(lbl2)	
End Sub

